
// 7-seg.c

#include "7-seg.h"

	
	// Variablen
    volatile uint16_t Ziffern_Table[] =
	{ZIFFER_0,ZIFFER_1,ZIFFER_2,ZIFFER_3,ZIFFER_4,ZIFFER_5,ZIFFER_6,ZIFFER_7,ZIFFER_8,ZIFFER_9,ZIFFER_C,ZIFFER_U,ZIFFER_AUS,
	 ZIFFER_E};
	volatile uint16_t Einer,Zehner,Hunderter,Punktwahl;

	//Funktionsprototypen
	void Display_Data (uint16_t, uint16_t);
	void Display_Menue (uint16_t);

		

	// Ziffern darstellen
	void Display_Data (uint16_t Ziffer, uint16_t Point)
	{
		Punktwahl = Point;
		Einer = Ziffern_Table[Ziffer%10];
		Zehner = Ziffern_Table[(Ziffer/10)%10];
		Hunderter = Ziffern_Table[Ziffer/100];
	}

	void Display_Menue (uint16_t Position) 
	{
		Punktwahl = 2;
		if 		(Position == 0) {Einer = Ziffern_Table[1]; Zehner = Ziffern_Table[1]; Hunderter = Ziffern_Table[10];}
		else if	(Position == 1) {Einer = Ziffern_Table[2]; Zehner = Ziffern_Table[1]; Hunderter = Ziffern_Table[10];}
		else if (Position == 2) {Einer = Ziffern_Table[1]; Zehner = Ziffern_Table[2]; Hunderter = Ziffern_Table[10];}
		else if (Position == 3) {Einer = Ziffern_Table[2]; Zehner = Ziffern_Table[2]; Hunderter = Ziffern_Table[10];}
		else if (Position == 4) {Einer = Ziffern_Table[1]; Zehner = Ziffern_Table[3]; Hunderter = Ziffern_Table[10];}
		else if (Position == 5) {Einer = Ziffern_Table[2]; Zehner = Ziffern_Table[3]; Hunderter = Ziffern_Table[10];}
		else if (Position == 6) {Einer = Ziffern_Table[12]; Zehner = Ziffern_Table[12]; Hunderter = Ziffern_Table[11];Punktwahl= AUS;}
		else if (Position == 7) {Einer = Ziffern_Table[12]; Zehner = Ziffern_Table[12]; Hunderter = Ziffern_Table[13];Punktwahl= AUS;}
	}

ISR (MULTIPLEX)
{
	static uint8_t timestep = 0;
	timestep++;

	if (timestep==1)
	 {
		 PORTB &= ~(1<<SEG_HUNDERTER); DATABUS = Einer; PORTB |= (1<<SEG_EINER);
		 if (Punktwahl == 1) {DATABUS |= POINT;}
		 else {DATABUS &= ~POINT;}
	 }
	
	if (timestep==2) 
	 {
	 	PORTB &= ~(1<<SEG_EINER); DATABUS = Zehner; PORTB |= (1<<SEG_ZEHNER);
		if (Punktwahl == 2) {DATABUS |= POINT;}
		else {DATABUS &= ~POINT;}
	 }

	if (timestep==3) 
	 {
	 	PORTB &= ~(1<<SEG_ZEHNER); DATABUS = Hunderter; PORTB |= (1<<SEG_HUNDERTER);
	 	if (Punktwahl == 3) {DATABUS |= POINT;}
		else {DATABUS &= ~POINT;}
	 }
	
	if (timestep>= 3) {timestep = 0;}
}
