
// 7-Seg.h


	//Includefiles
	#include <avr/interrupt.h>
	#include <stdio.h>
	#include <stdint.h>
	#include <avr/io.h>
	#include <string.h>
	#include <util/delay.h>


	//Defines
	// Segment-Pinzuweisung
	#define SEG_A	(1<<PD0)
	#define SEG_B	(1<<PD2)
	#define SEG_C	(1<<PD5)
	#define SEG_D	(1<<PD6)
	#define SEG_E	(1<<PD4)
	#define SEG_F	(1<<PD3)
	#define SEG_G	(1<<PD1)
	#define POINT	(1<<PD7)
	#define DATABUS (PORTD)

	// Zifferncodierung
	#define ZIFFER_0 (SEG_A|SEG_B|SEG_C|SEG_D|SEG_E|SEG_F)
	#define ZIFFER_1 (SEG_B|SEG_C)
	#define ZIFFER_2 (SEG_A|SEG_B|SEG_G|SEG_E|SEG_D)
	#define ZIFFER_3 (SEG_A|SEG_B|SEG_G|SEG_C|SEG_D)
	#define ZIFFER_4 (SEG_F|SEG_G|SEG_B|SEG_C)
	#define ZIFFER_5 (SEG_A|SEG_F|SEG_G|SEG_C|SEG_D)
	#define ZIFFER_6 (SEG_A|SEG_C|SEG_D|SEG_E|SEG_F|SEG_G)
	#define ZIFFER_7 (SEG_A|SEG_B|SEG_C)
	#define ZIFFER_8 (SEG_A|SEG_B|SEG_C|SEG_D|SEG_E|SEG_F|SEG_G)
	#define ZIFFER_9 (SEG_A|SEG_B|SEG_C|SEG_D|SEG_F|SEG_G)
	#define ZIFFER_C (SEG_A|SEG_F|SEG_E|SEG_D)
	#define ZIFFER_U (SEG_F|SEG_E|SEG_D|SEG_C|SEG_B)
	#define ZIFFER_E (SEG_A|SEG_F|SEG_G|SEG_E|SEG_D)
	#define ZIFFER_AUS 0
	#define AUS 0


	//Multiplexer
	#define SEG_EINER 		PB1
	#define SEG_ZEHNER		PB0
	#define SEG_HUNDERTER	PB2 

	// Zeitgeber fr Multiplexer
	#define MULTIPLEX TIMER0_OVF_vect

	//Funktionen globalisieren
	extern void Display_Data (uint16_t, uint16_t);
	extern void Display_Menue (uint16_t);
